<?php
/**
 *       .
 *
 * @author   <vova_33@gala.net>
 * @link http://www.simplecoding.org
 */
/**
 *  Phing Task
 */
require_once 'phing/Task.php';
/**
 *     .
 */
class convEncodingTask extends Task {
	/**
     *  
     *
     * @var  FileSet
     */
    protected $filesets    = array();
    /**
     *   ,       
     *
     * @var boolean
     */
    protected $failonerror = false;
    /**
     *       
     *
     * @var  string
     */
    protected $targetDir;
    /**
     *  
     *
     * @var  string
     */
    protected $fromEncoding;
    /**
     *  
     *
     * @var  string
     */
    protected $toEncoding;

    /**
     *    
     */
    public function createFileSet() {
        $num = array_push($this->filesets, new FileSet());
        return $this->filesets[$num - 1];
    }

    /**
     *  failonerror
     *
     * @param boolean $value
     */
    public function setFailonerror($value) {
        $this->failonerror = $value;
    }

    /**
     *  targetDir
     *
     * @param  string  $targetDir
     */
    public function setTargetDir($targetDir) {
        $this->targetDir = $targetDir;
    }
    /**
     *  fromEncoding
     *
     * @param  string  $formEncoding
     */
    public function setFromEncoding($fromEncoding) {
        $this->fromEncoding = $fromEncoding;
    }
    /**
     *  toEncoding
     *
     * @param  string  $toEncoding
     */
    public function setToEncoding($toEncoding) {
        $this->toEncoding = $toEncoding;
    }
	
    /**
     * 
     */
    public function init() {
        return true;
    }

    /**
     *   (   )
     */
    public function main() {
		//,    Multibyte String
		if (function_exists("mb_convert_encoding")) {
			// 
			//(       FileSet)
	        foreach ($this->filesets as $fs) {
	            try {
					//     
	                $files = $fs->getDirectoryScanner($this->project)->getIncludedFiles();
	                $fullPath = realpath($fs->getDir($this->project));
					//   
	                foreach ($files as $file) {
	                    $this->log('Converting file ' . $file);
						//    
						$target = $this->targetDir . '/' . str_replace($fullPath, '', $file);
						if (file_exists(dirname($target)) == false) {
							mkdir(dirname($target), 0700, true);
						}
						// 
						file_put_contents($target, mb_convert_encoding(file_get_contents($fullPath . '/' . $file), $this->toEncoding, $this->fromEncoding));
	                }
	            } catch (BuildException $be) {
	                //        
	                if ($this->failonerror) {
						throw $be;
	                } else {
	                    $this->log($be->getMessage(), $this->quiet ? Project::MSG_VERBOSE : Project::MSG_WARN);
	                }
				}
			}
		}
		else {
			// (  mb_convert_encoding)
			$be = new BuildException('No Multibyte String support');
			if ($this->failonerror) {
				throw $be;
			}
			else {
				//    build ,   ,    
				$this->log($be->getMessage(), $this->quiet ? Project::MSG_VERBOSE : Project::MSG_WARN);
			}
		}
    }
}
?>